classification
Title: Meta-issue for "Invent with Python" IDLE feedback
Type: Stage:
Components: IDLE Versions: Python 3.5, Python 3.4, Python 2.7
process
Status: open Resolution:
Dependencies: 4832 10364 10747 13884 15308 17535 17721 17942 18444 Superseder:
Assigned To: Nosy List: Nebelhom, Todd.Rovito, kbk, ncoghlan, ned.deily, roger.serwy, terry.reedy
Priority: normal Keywords:

Created on 2011-11-30 00:31 by ncoghlan, last changed 2014-10-20 04:59 by terry.reedy.

Messages (11)
msg148629 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2011-11-30 00:31
This is a meta-issue for the following blog post: http://inventwithpython.com/blog/2011/11/29/the-things-i-hate-about-idle-that-i-wish-someone-would-fix/

There are a bunch of good ideas there that should be split out into a number of separate bug reports and feature requests. This meta-bug is just a quick and dirty way to suggest doing so, and giving people a place to collaborate on the task.
msg148630 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2011-11-30 00:35
If you decide to work on one of the problems or feature requests mentioned in that post:

1. Create a separate, appropriately titled, tracker issue
2. Add that issue to the Dependencies field on this one.
3. Add a comment here to map the point number from the blog post to the relevant tracker issue number (so that issues don't get doubled up).
msg148631 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2011-11-30 00:39
Also add dependencies and links for any already known issues. For example:

#10747 covers point 16) (re. version numbers in Windows shortcuts)
msg148645 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2011-11-30 09:11
#10364 covers point 7 (make .py default added extension on save)
msg148655 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2011-11-30 14:49
#2704 covers point 1 (In the shell window, if you click anywhere but on the current line and move the cursor there, the window stops handling key strokes.)

#3851 covers point 1.1) "Pressing the Home key moves the cursor before the >>> prompt, which then makes the keyboard unresponsive."

#7136 covers point 5) "Opening a file editor window or a shell window isn’t clear."

#6804 and #6858 are also related to point 7 "It’s too easy to forget the .py extension when saving a file."

#694339 covers point 13) "The Indent Region and Dedent Region lines use the keyboard shortcut Ctrl-] and Ctrl-[, even though nobody uses that because you can indent the region by pressing tab."

#5150 is related to point 14) "Get rid of the Format > “Strip trailing whitespace” option from the menu"

#10747 covers point 16) "The Windows shortcuts for IDLE don’t have the version in their name."
msg152193 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2012-01-28 21:55
#13884 has a patch to address point 4) ANNOYANCE: Get rid of the detachable menus feature.
msg185116 - (view) Author: Todd Rovito (Todd.Rovito) * Date: 2013-03-24 05:17
http://bugs.python.org/issue17535 covers issue 12 Add an option to show line numbers along the left side of the editor window, and have it enabled by default.
msg187224 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2013-04-18 05:26
Issue17721 addresses part of point 11) "And am I the only person who noticed that the Help button doesn’t actually do anything?"
msg193026 - (view) Author: Todd Rovito (Todd.Rovito) * Date: 2013-07-14 04:45
1.1) "Pressing the Home key moves the cursor before the >>> prompt, which then makes the keyboard unresponsive." 

This issue is still broken on Mac OS X.

http://bugs.python.org/issue18444
msg229711 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-10-20 03:16
http://inventwithpython.com/blog/2011/11/29/the-things-i-hate-about-idle-that-i-wish-someone-would-fix/comment-page-1/#comment-2726
Professor teaching Python says '4. UNFRIENDLY: Forcing a kill of a running script by clicking the X close button brings up the scary message of “killing” something.'. 

>>> input('say something')
say something  <try to close shell with [x]>

Unless someone objects within a few days, I will change message title and text to
Stop your program?
Your program is still running!  Do you want to stop it and exit the Shell?
msg229713 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-10-20 04:59
General comment: I am less willing to casually change defaults or even remove features, and upset current habits of current users, than the blogger and responders.  I now have an organized list of all open Idle issues.  I am checking this list against that and am incorporating data from messages above.

1a. #2704 (limited from request) jump to prompt when hitting character key.
1b. (my idea) add run-undo that will delete output and reactivate previous input line for editing.
1.1 #3851,  #17060, #18444 HOME, fixed on non-mac,
1.2 copy on highlight. Rejected. I constantly use auto-copy to >>>.
2. Debug highlight.  If still true, probably only or worse on Windows.
3. 15308 Stop execution. (same as control-C)  Restart Shell (C-F6) does more that stopping a statement, but is only sure way to stop.
4. #13884 Tear of menu optional or gone
5. #7136 New Window -> New Editor Window
6. Pygame issue or perhaps fixed as similar complaints have been.
7. #10364 .py extension, #6804 and #6858 are related.
8a. Delete ZoomHeight.  Low priority, someone might use it.
8b. Tile Shell & Editor:  I would like to tile two notebooks (#9262).
9. Surrounding parens.  delete or make auto
10. #17942 Improve debugger gui.
11. #17721 Help button.  Also Improve Idle config dialog.  Maybe.
12. #17535 Line numbers in editor.
13. #694339 dedent with shift Tab.
14. #5150 Strip trailing whitespace: auto for .py (including trailing \ns.
15. Save dialog: Save, Don't Save instead of yes/ no.
16. #10747 Icon version
17. c-wheel, change font size (see turtledemo #21933).
U1. Specify argv when run.
U2. #19406 include pip (Win, Mac, at least)
U3. Detect if 2.x or 3.x code (could at least 
U4. Repeat of 1a
R4.1 Idle and input(); works now
R4.2 Idle and turtle; works now
R4.3a Highlight blocks #6804 in part
R4.3b 22354 Highlight tabs versus spaces.
R5.1 Mac focus issue.
R5.2
History
Date User Action Args
2014-10-20 04:59:27terry.reedysetdependencies: + IDLE: Remove tear-off menu feature, IDLE: Add an option to show line numbers along the left side of the editor window, and have it enabled by default., IDLE Debugger: Improve GUI
messages: + msg229713
2014-10-20 03:16:07terry.reedysetmessages: + msg229711
2014-06-20 18:47:21zach.waresetdependencies: + IDLE: Mac OS X pressing ctrl-A in Python shell moved cursor before the prompt, which then makes the keyboard unresponsive.
versions: + Python 2.7, Python 3.5, - Python 3.3
2013-08-14 19:33:39kbksetnosy: + kbk
2013-07-14 04:45:10Todd.Rovitosetmessages: + msg193026
2013-06-15 18:44:32terry.reedysetversions: + Python 3.4
2013-04-18 05:26:42roger.serwysetdependencies: + Help button on preference window doesn't work
messages: + msg187224
2013-03-24 05:17:39Todd.Rovitosetmessages: + msg185116
2012-10-22 15:48:18berker.peksagsetnosy: - berker.peksag
2012-10-18 16:06:22Todd.Rovitosetnosy: + Todd.Rovito
2012-07-09 21:48:36roger.serwysetdependencies: + IDLE does not supply a default ext of .py on Windows or OS X for new file saves
2012-07-09 20:27:59roger.serwysetdependencies: + IDLE - add an "Interrupt Execution" to shell menu
2012-01-28 21:55:06roger.serwysetmessages: + msg152193
2011-11-30 22:18:42Nebelhomsetnosy: + Nebelhom
2011-11-30 14:49:19roger.serwysetmessages: + msg148655
2011-11-30 12:45:29berker.peksagsetnosy: + berker.peksag
2011-11-30 09:11:10ned.deilysetnosy: + ned.deily
dependencies: + IDLE: make .py default added extension on save
messages: + msg148645
2011-11-30 03:05:40roger.serwysetnosy: + roger.serwy
2011-11-30 02:41:04terry.reedysetnosy: + terry.reedy
2011-11-30 00:39:59ncoghlansetdependencies: + Include version info in Windows shortcuts
messages: + msg148631
2011-11-30 00:35:46ncoghlansetmessages: + msg148630
2011-11-30 00:31:22ncoghlancreate